Index: /palm/trunk/SOURCE/wall_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/wall_fluxes.f90	(revision 1352)
+++ /palm/trunk/SOURCE/wall_fluxes.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -148,6 +148,6 @@
 
 
-       zp         = 0.5 * ( (a+c1) * dy + (b+c2) * dx )
-       wall_flux  = 0.0
+       zp         = 0.5_wp * ( (a+c1) * dy + (b+c2) * dx )
+       wall_flux  = 0.0_wp
        wall_index = NINT( a+ 2*b + 3*c1 + 4*c2 )
 
@@ -155,5 +155,5 @@
           DO  j = nys, nyn
 
-             IF ( wall(j,i) /= 0.0 )  THEN
+             IF ( wall(j,i) /= 0.0_wp )  THEN
 !
 !--             All subsequent variables are computed for the respective
@@ -165,15 +165,15 @@
                    rifs  = rif_wall(k,j,i,wall_index)
 
-                   u_i   = a * u(k,j,i) + c1 * 0.25 *                          &
+                   u_i   = a * u(k,j,i) + c1 * 0.25_wp *                       &
                            ( u(k+1,j,i+1) + u(k+1,j,i) + u(k,j,i+1) + u(k,j,i) )
 
-                   v_i   = b * v(k,j,i) + c2 * 0.25 *                          &
+                   v_i   = b * v(k,j,i) + c2 * 0.25_wp *                       &
                            ( v(k+1,j+1,i) + v(k+1,j,i) + v(k,j+1,i) + v(k,j,i) )
 
-                   ws    = ( c1 + c2 ) * w(k,j,i) + 0.25 * (                   &
+                   ws    = ( c1 + c2 ) * w(k,j,i) + 0.25_wp * (                &
                      a * ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) + w(k,j,i) ) &
                    + b * ( w(k-1,j-1,i) + w(k-1,j,i) + w(k,j-1,i) + w(k,j,i) ) &
-                                                           )
-                   pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) +              &
+                                                              )
+                   pt_i  = 0.5_wp * ( pt(k,j,i) + a *  pt(k,j,i-1) +           &
                                    b * pt(k,j-1,i) + ( c1 + c2 ) * pt(k+1,j,i) )
 
@@ -187,10 +187,10 @@
 !
 !--                (3) Compute wall friction velocity us_wall
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--                   Stable stratification (and neutral)
                       us_wall = kappa * vel_total / ( LOG( zp / z0(j,i) ) +    &
-                                            5.0 * rifs * ( zp - z0(j,i) ) / zp &
+                                         5.0_wp * rifs * ( zp - z0(j,i) ) / zp &
                                                     )
                    ELSE
@@ -198,12 +198,12 @@
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       us_wall = kappa * vel_total / (                          &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                     )
                    ENDIF
@@ -212,6 +212,6 @@
 !--                (4) Compute zp/L (corresponds to neutral Richardson flux
 !--                    number rifs)
-                   rifs = -1.0 * zp * kappa * g * wspts / ( pt_i *             &
-                                                        ( us_wall**3 + 1E-30 ) )
+                   rifs = -1.0_wp * zp * kappa * g * wspts /                   &
+                          ( pt_i * ( us_wall**3 + 1E-30 ) )
 
 !
@@ -227,5 +227,5 @@
 !
 !--                (5) Compute wall_flux (u'v', v'u', w'v', or w'u')
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
@@ -234,5 +234,5 @@
                               ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / &
                               (  LOG( zp / z0(j,i) ) +                         &
-                                 5.0 * rifs * ( zp - z0(j,i) ) / zp            &
+                                 5.0_wp * rifs * ( zp - z0(j,i) ) / zp         &
                               )
                    ELSE
@@ -240,13 +240,13 @@
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       wall_flux(k,j,i) = kappa *                               &
                            ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / (  &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                                             )
                    ENDIF
@@ -333,6 +333,6 @@
 
 
-       zp         = 0.5 * ( (a+c1) * dy + (b+c2) * dx )
-       wall_flux  = 0.0
+       zp         = 0.5_wp * ( (a+c1) * dy + (b+c2) * dx )
+       wall_flux  = 0.0_wp
        wall_index = NINT( a+ 2*b + 3*c1 + 4*c2 )
 
@@ -346,5 +346,5 @@
           DO  j = j_south, j_north
 
-             IF ( wall(j,i) /= 0.0 )  THEN
+             IF ( wall(j,i) /= 0.0_wp )  THEN
 !
 !--             All subsequent variables are computed for the respective
@@ -357,15 +357,15 @@
                    rifs  = rif_wall(k,j,i,wall_index)
 
-                   u_i   = a * u(k,j,i) + c1 * 0.25 *                          &
+                   u_i   = a * u(k,j,i) + c1 * 0.25_wp *                       &
                            ( u(k+1,j,i+1) + u(k+1,j,i) + u(k,j,i+1) + u(k,j,i) )
 
-                   v_i   = b * v(k,j,i) + c2 * 0.25 *                          &
+                   v_i   = b * v(k,j,i) + c2 * 0.25_wp *                       &
                            ( v(k+1,j+1,i) + v(k+1,j,i) + v(k,j+1,i) + v(k,j,i) )
 
-                   ws    = ( c1 + c2 ) * w(k,j,i) + 0.25 * (                   &
+                   ws    = ( c1 + c2 ) * w(k,j,i) + 0.25_wp * (                &
                      a * ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) + w(k,j,i) ) &
                    + b * ( w(k-1,j-1,i) + w(k-1,j,i) + w(k,j-1,i) + w(k,j,i) ) &
-                                                           )
-                   pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) +              &
+                                                              )
+                   pt_i  = 0.5_wp * ( pt(k,j,i) + a *  pt(k,j,i-1) +           &
                                    b * pt(k,j-1,i) + ( c1 + c2 ) * pt(k+1,j,i) )
 
@@ -379,10 +379,10 @@
 !
 !--                (3) Compute wall friction velocity us_wall
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--                   Stable stratification (and neutral)
                       us_wall = kappa * vel_total / ( LOG( zp / z0(j,i) ) +    &
-                                            5.0 * rifs * ( zp - z0(j,i) ) / zp &
+                                         5.0_wp * rifs * ( zp - z0(j,i) ) / zp &
                                                     )
                    ELSE
@@ -390,12 +390,12 @@
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       us_wall = kappa * vel_total / (                          &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                     )
                    ENDIF
@@ -404,6 +404,6 @@
 !--                (4) Compute zp/L (corresponds to neutral Richardson flux
 !--                    number rifs)
-                   rifs = -1.0 * zp * kappa * g * wspts / ( pt_i *             &
-                                                        ( us_wall**3 + 1E-30 ) )
+                   rifs = -1.0_wp * zp * kappa * g * wspts /                   &
+                          ( pt_i * ( us_wall**3 + 1E-30 ) )
 
 !
@@ -419,5 +419,5 @@
 !
 !--                (5) Compute wall_flux (u'v', v'u', w'v', or w'u')
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
@@ -426,5 +426,5 @@
                               ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / &
                               (  LOG( zp / z0(j,i) ) +                         &
-                                 5.0 * rifs * ( zp - z0(j,i) ) / zp            &
+                                 5.0_wp * rifs * ( zp - z0(j,i) ) / zp         &
                               )
                    ELSE
@@ -432,13 +432,13 @@
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       wall_flux(k,j,i) = kappa *                               &
                            ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / (  &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                                             )
                    ENDIF
@@ -511,6 +511,6 @@
 
 
-       zp         = 0.5 * ( (a+c1) * dy + (b+c2) * dx )
-       wall_flux  = 0.0
+       zp         = 0.5_wp * ( (a+c1) * dy + (b+c2) * dx )
+       wall_flux  = 0.0_wp
        wall_index = NINT( a+ 2*b + 3*c1 + 4*c2 )
 
@@ -524,15 +524,15 @@
           rifs  = rif_wall(k,j,i,wall_index)
 
-          u_i   = a * u(k,j,i) + c1 * 0.25 *                                   &
+          u_i   = a * u(k,j,i) + c1 * 0.25_wp *                                &
                   ( u(k+1,j,i+1) + u(k+1,j,i) + u(k,j,i+1) + u(k,j,i) )
 
-          v_i   = b * v(k,j,i) + c2 * 0.25 *                                   &
+          v_i   = b * v(k,j,i) + c2 * 0.25_wp *                                &
                   ( v(k+1,j+1,i) + v(k+1,j,i) + v(k,j+1,i) + v(k,j,i) )
 
-          ws    = ( c1 + c2 ) * w(k,j,i) + 0.25 * (                            &
+          ws    = ( c1 + c2 ) * w(k,j,i) + 0.25_wp * (                         &
                      a * ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) + w(k,j,i) ) &
                    + b * ( w(k-1,j-1,i) + w(k-1,j,i) + w(k,j-1,i) + w(k,j,i) ) &
-                                                  )
-          pt_i  = 0.5 * ( pt(k,j,i) + a *  pt(k,j,i-1) + b * pt(k,j-1,i)       &
+                                                     )
+          pt_i  = 0.5_wp * ( pt(k,j,i) + a *  pt(k,j,i-1) + b * pt(k,j-1,i)    &
                           + ( c1 + c2 ) * pt(k+1,j,i) )
 
@@ -546,10 +546,10 @@
 !
 !--       (3) Compute wall friction velocity us_wall
-          IF ( rifs >= 0.0 )  THEN
+          IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--          Stable stratification (and neutral)
              us_wall = kappa * vel_total / ( LOG( zp / z0(j,i) ) +             &
-                                            5.0 * rifs * ( zp - z0(j,i) ) / zp &
+                                         5.0_wp * rifs * ( zp - z0(j,i) ) / zp &
                                            )
           ELSE
@@ -557,12 +557,12 @@
 !
 !--          Unstable stratification
-             h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-             h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+             h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+             h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
              us_wall = kappa * vel_total / (                                   &
                   LOG( zp / z0(j,i) ) -                                        &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
+                  LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (             &
+                       ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +         &
+                       2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )                    &
                                            )
           ENDIF
@@ -571,5 +571,6 @@
 !--       (4) Compute zp/L (corresponds to neutral Richardson flux number 
 !--           rifs)
-          rifs = -1.0 * zp * kappa * g * wspts / ( pt_i * (us_wall**3 + 1E-30) )
+          rifs = -1.0_wp * zp * kappa * g * wspts /                            &
+                  ( pt_i * (us_wall**3 + 1E-30) )
 
 !
@@ -584,5 +585,5 @@
 !
 !--       (5) Compute wall_flux (u'v', v'u', w'v', or w'u')
-          IF ( rifs >= 0.0 )  THEN
+          IF ( rifs >= 0.0_wp )  THEN
 
 !
@@ -591,5 +592,5 @@
                             ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) /   &
                             (  LOG( zp / z0(j,i) ) +                           &
-                               5.0 * rifs * ( zp - z0(j,i) ) / zp              &
+                               5.0_wp * rifs * ( zp - z0(j,i) ) / zp           &
                             )
           ELSE
@@ -597,13 +598,13 @@
 !
 !--          Unstable stratification
-             h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-             h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+             h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+             h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
              wall_flux(k) = kappa *                                            &
                   ( a*u(k,j,i) + b*v(k,j,i) + (c1+c2)*w(k,j,i) ) / (           &
                   LOG( zp / z0(j,i) ) -                                        &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
+                  LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (             &
+                       ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +         &
+                       2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )                    &
                                                                    )
           ENDIF
@@ -680,6 +681,6 @@
 
 
-       zp         = 0.5 * ( (a+c1) * dy + (b+c2) * dx )
-       wall_flux  = 0.0
+       zp         = 0.5_wp * ( (a+c1) * dy + (b+c2) * dx )
+       wall_flux  = 0.0_wp
        wall_index = NINT( a+ 2*b + 3*c1 + 4*c2 )
 
@@ -687,5 +688,5 @@
           DO  j = nys, nyn
 
-             IF ( wall(j,i) /= 0.0 )  THEN
+             IF ( wall(j,i) /= 0.0_wp )  THEN
 !
 !--             All subsequent variables are computed for scalar locations.
@@ -698,25 +699,27 @@
                       kk = k-1
                    ENDIF
-                   rifs  = 0.5 * ( rif_wall(k,j,i,wall_index) +                &
-                          a * rif_wall(k,j,i+1,1) +  b * rif_wall(k,j+1,i,2) + &
-                          c1 * rif_wall(kk,j,i,3) + c2 * rif_wall(kk,j,i,4)    &
-                                 )
-
-                   u_i   = 0.5 * ( u(k,j,i) + u(k,j,i+1) )
-                   v_i   = 0.5 * ( v(k,j,i) + v(k,j+1,i) )
-                   ws    = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
+                   rifs  = 0.5_wp * (      rif_wall(k,j,i,wall_index) +        &
+                                      a  * rif_wall(k,j,i+1,1)        +        &
+                                      b  * rif_wall(k,j+1,i,2)        +        &
+                                      c1 * rif_wall(kk,j,i,3)         +        &
+                                      c2 * rif_wall(kk,j,i,4)                  &
+                                    )
+
+                   u_i   = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
+                   v_i   = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
+                   ws    = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
 !
 !--                (2) Compute wall-parallel absolute velocity vel_total and
 !--                interpolate appropriate velocity component vel_zp.
                    vel_total = SQRT( ws**2 + (a+c1) * u_i**2 + (b+c2) * v_i**2 )
-                   vel_zp = 0.5 * ( a * u_i + b * v_i + (c1+c2) * ws )
+                   vel_zp    = 0.5_wp * ( a * u_i + b * v_i + (c1+c2) * ws )
 !
 !--                (3) Compute wall friction velocity us_wall
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--                   Stable stratification (and neutral)
                       us_wall = kappa * vel_total / ( LOG( zp / z0(j,i) ) +    &
-                                            5.0 * rifs * ( zp - z0(j,i) ) / zp &
+                                         5.0_wp * rifs * ( zp - z0(j,i) ) / zp &
                                                     )
                    ELSE
@@ -724,12 +727,12 @@
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       us_wall = kappa * vel_total / (                          &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                     )
                    ENDIF
@@ -741,22 +744,22 @@
 !--                (5) Compute wall_flux (u'v', v'u', w'v', or w'u')
 
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--                   Stable stratification (and neutral)
-                      wall_flux(k,j,i) = kappa *  vel_zp /                     &
-                          ( LOG( zp/z0(j,i) ) + 5.0*rifs * ( zp-z0(j,i) ) / zp )
+                      wall_flux(k,j,i) = kappa * vel_zp / ( LOG( zp/z0(j,i) ) +&
+                                         5.0_wp * rifs * ( zp-z0(j,i) ) / zp )
                    ELSE
 
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       wall_flux(k,j,i) = kappa * vel_zp / (                    &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                           )
                    ENDIF
@@ -836,6 +839,6 @@
 
 
-       zp         = 0.5 * ( (a+c1) * dy + (b+c2) * dx )
-       wall_flux  = 0.0
+       zp         = 0.5_wp * ( (a+c1) * dy + (b+c2) * dx )
+       wall_flux  = 0.0_wp
        wall_index = NINT( a+ 2*b + 3*c1 + 4*c2 )
 
@@ -851,5 +854,6 @@
 !--             All subsequent variables are computed for scalar locations
                 IF ( k >= nzb_diff_s_inner(j,i)-1  .AND.                       &
-                     k <= nzb_diff_s_outer(j,i)-2  .AND.  wall(j,i) /= 0.0 )  THEN
+                     k <= nzb_diff_s_outer(j,i)-2  .AND.                       &
+                     wall(j,i) /= 0.0_wp )         THEN
 !
 !--                (1) Compute rifs, u_i, v_i, and ws
@@ -859,25 +863,27 @@
                       kk = k-1
                    ENDIF
-                   rifs  = 0.5 * ( rif_wall(k,j,i,wall_index) +                &
-                          a * rif_wall(k,j,i+1,1) +  b * rif_wall(k,j+1,i,2) + &
-                          c1 * rif_wall(kk,j,i,3) + c2 * rif_wall(kk,j,i,4)    &
-                                 )
-
-                   u_i   = 0.5 * ( u(k,j,i) + u(k,j,i+1) )
-                   v_i   = 0.5 * ( v(k,j,i) + v(k,j+1,i) )
-                   ws    = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
+                   rifs  = 0.5_wp * (      rif_wall(k,j,i,wall_index) +        &
+                                      a  * rif_wall(k,j,i+1,1)        +        &
+                                      b  * rif_wall(k,j+1,i,2)        +        &
+                                      c1 * rif_wall(kk,j,i,3)         +        &
+                                      c2 * rif_wall(kk,j,i,4)                  &
+                                    )
+
+                   u_i   = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
+                   v_i   = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
+                   ws    = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
 !
 !--                (2) Compute wall-parallel absolute velocity vel_total and
 !--                interpolate appropriate velocity component vel_zp.
                    vel_total = SQRT( ws**2 + (a+c1) * u_i**2 + (b+c2) * v_i**2 )
-                   vel_zp = 0.5 * ( a * u_i + b * v_i + (c1+c2) * ws )
+                   vel_zp    = 0.5_wp * ( a * u_i + b * v_i + (c1+c2) * ws )
 !
 !--                (3) Compute wall friction velocity us_wall
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--                   Stable stratification (and neutral)
                       us_wall = kappa * vel_total / ( LOG( zp / z0(j,i) ) +    &
-                                            5.0 * rifs * ( zp - z0(j,i) ) / zp &
+                                         5.0_wp * rifs * ( zp - z0(j,i) ) / zp &
                                                     )
                    ELSE
@@ -885,12 +891,12 @@
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       us_wall = kappa * vel_total / (                          &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                     )
                    ENDIF
@@ -902,22 +908,24 @@
 !--                (5) Compute wall_flux (u'v', v'u', w'v', or w'u')
 
-                   IF ( rifs >= 0.0 )  THEN
+                   IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--                   Stable stratification (and neutral)
-                      wall_flux(k,j,i) = kappa *  vel_zp /                     &
-                          ( LOG( zp/z0(j,i) ) + 5.0*rifs * ( zp-z0(j,i) ) / zp )
+                      wall_flux(k,j,i) = kappa *  vel_zp / (                   &
+                                         LOG( zp/z0(j,i) ) +                   &
+                                         5.0_wp * rifs * ( zp-z0(j,i) ) / zp   &
+                                                           )
                    ELSE
 
 !
 !--                   Unstable stratification
-                      h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-                      h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+                      h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+                      h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
                       wall_flux(k,j,i) = kappa * vel_zp / (                    &
                            LOG( zp / z0(j,i) ) -                               &
-                           LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (          &
-                                ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +      &
-                                2.0 * ( ATAN( h1 ) - ATAN( h2 ) )              &
+                           LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (    &
+                                ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +&
+                                2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )           &
                                                           )
                    ENDIF
@@ -981,6 +989,6 @@
 
 
-       zp         = 0.5 * ( (a+c1) * dy + (b+c2) * dx )
-       wall_flux  = 0.0
+       zp         = 0.5_wp * ( (a+c1) * dy + (b+c2) * dx )
+       wall_flux  = 0.0_wp
        wall_index = NINT( a+ 2*b + 3*c1 + 4*c2 )
 
@@ -996,25 +1004,27 @@
              kk = k-1
           ENDIF
-          rifs  = 0.5 * ( rif_wall(k,j,i,wall_index) +                         &
-                          a * rif_wall(k,j,i+1,1) +  b * rif_wall(k,j+1,i,2) + &
-                          c1 * rif_wall(kk,j,i,3) + c2 * rif_wall(kk,j,i,4)    &
-                        )
-
-          u_i   = 0.5 * ( u(k,j,i) + u(k,j,i+1) )
-          v_i   = 0.5 * ( v(k,j,i) + v(k,j+1,i) )
-          ws    = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
+          rifs  = 0.5_wp * (      rif_wall(k,j,i,wall_index) +                 &
+                             a  * rif_wall(k,j,i+1,1)        +                 &
+                             b  * rif_wall(k,j+1,i,2)        +                 &
+                             c1 * rif_wall(kk,j,i,3)         +                 &
+                             c2 * rif_wall(kk,j,i,4)                           &
+                           )
+
+          u_i   = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
+          v_i   = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
+          ws    = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
 !
 !--       (2) Compute wall-parallel absolute velocity vel_total and
 !--       interpolate appropriate velocity component vel_zp.
           vel_total = SQRT( ws**2 + (a+c1) * u_i**2 + (b+c2) * v_i**2 )
-          vel_zp = 0.5 * ( a * u_i + b * v_i + (c1+c2) * ws )
+          vel_zp    = 0.5_wp * ( a * u_i + b * v_i + (c1+c2) * ws )
 !
 !--       (3) Compute wall friction velocity us_wall
-          IF ( rifs >= 0.0 )  THEN
+          IF ( rifs >= 0.0_wp )  THEN
 
 !
 !--          Stable stratification (and neutral)
              us_wall = kappa * vel_total / ( LOG( zp / z0(j,i) ) +             &
-                                            5.0 * rifs * ( zp - z0(j,i) ) / zp &
+                                         5.0_wp * rifs * ( zp - z0(j,i) ) / zp &
                                            )
           ELSE
@@ -1022,12 +1032,12 @@
 !
 !--          Unstable stratification
-             h1 = SQRT( SQRT( 1.0 - 16.0 * rifs ) )
-             h2 = SQRT( SQRT( 1.0 - 16.0 * rifs * z0(j,i) / zp ) )
+             h1 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs ) )
+             h2 = SQRT( SQRT( 1.0_wp - 16.0_wp * rifs * z0(j,i) / zp ) )
 
              us_wall = kappa * vel_total / (                                   &
                   LOG( zp / z0(j,i) ) -                                        &
-                  LOG( ( 1.0 + h1 )**2 * ( 1.0 + h1**2 ) / (                   &
-                       ( 1.0 + h2 )**2 * ( 1.0 + h2**2 )   ) ) +               &
-                       2.0 * ( ATAN( h1 ) - ATAN( h2 ) )                       &
+                  LOG( ( 1.0_wp + h1 )**2 * ( 1.0_wp + h1**2 ) / (             &
+                       ( 1.0_wp + h2 )**2 * ( 1.0_wp + h2**2 )   ) ) +         &
+                       2.0_wp * ( ATAN( h1 ) - ATAN( h2 ) )                    &
                                            )
           ENDIF
